uses dos;

type
    xb  = array[1..65535] of byte;
    ECHOTAGS = record
    Name : array[1..1500] of string[30];
    Dir  : array[1..1500] of string[8];
    W    : array[1..1500] of byte;
    end;

const Win : array[0..111]of byte = (
$C0,$C1,$C2,$C3,$C4,$C5,$C6,$C7,$C8,$C9,$CA,$CB,$CC,$CD,$CE,
$CF,$D0,$D1,$D2,$D3,$D4,$D5,$D6,$D7,$D8,$D9,$DA,$DB,$DC,$DD,
$DE,$DF,$E0,$E1,$E2,$E3,$E4,$E5,$E6,$E7,$E8,$E9,$EA,$EB,$EC,
$ED,$EE,$EF,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,
$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,
$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,
$20,$20,$20,$20,$20,$20,$F0,$F1,$F2,$F3,$F4,$F5,$F6,$F7,$F8,
$F9,$FA,$FB,$FC,$FD,$FE,$FF
);

var
   buffer : ^xb;
   e : array[1..4] of ^ECHOTAGS;
   Echos : integer;
   CurNumba : longint;
   fl,f1l : longint;
   fz,f1z : longint;
   fp,f1p : longint;
   ap,a1p : longint;
   cb,c1b : longint;

var

   fx : file;
   f1 : file;
   fc : file of char;
   g,g1,g2,gu,gtemp : string;
   path : string[70];
   i    : searchrec;
   squishpath: string[70];
   FMPT : string[6];
   ln   : integer;

Procedure OFile(name : string);
var
   temp : longint;
   i    : searchrec;
begin
FindFirst(name,AnyFile,i);
if DOSERROR<>0 then begin WriteLn('Fatal: Can''t find file',name,chr(10),chr(13),'exiting.'); halt; end;
assign(fx,name);
reset(fx,1);
fp:=0;
fz:=filesize(fx);
cb:=0;
temp:=fz;
if temp>65535 then temp:=65535;
blockread(fx,buffer^,temp);
end;

Procedure CFile;
begin
Close(fx);
end;

Function Position : longint;
begin
position:=cb*65535+ap-1;
end;


Procedure ABSeek(position : longint);
var
   t1,t2,temp : longint;
begin
t1:=position div 65535;
if t1<>0 then t2:=position mod (t1*65535) else t2:=position;
seek(fx,t1*65535);

temp:=fz - (t1 * 65535);
if temp>65535 then temp:=65535;
blockread(fx,buffer^,temp);
cb:=t1;
ap:=t2+1;
end;

Procedure FSeek(position : longint);
begin
fp:=position;
if (position div 65535) = cb then begin
if cb<>0 then ap:=(position mod (cb*65535))+1
else ap:=position+1
   end
   else ABSeek(position);
end;

Function ReadC : char;
begin
ReadC:=char(buffer^[ap]);
inc(ap);
inc(fp);

if ap>65535 then FSeek(fp);

end;

Function EoFx : boolean;
begin
EoFx:=false;

if fp>fz then EoFx:=true;

end;

Function SP (c : char) : boolean;
begin
if (c=' ') or (c=chr(09)) then SP:=true else SP:=false;
end;

Function FStr(s : string) : boolean;
var
   x : integer;
   c : char;
begin
x:=1;
repeat
c:=ReadC;
if Upcase(c)=s[x] then
 begin
 inc(x);

 if x>length(s) then

  begin
  FStr:=true;
  exit;
  end;
 end else begin FStr:=false; exit; end;
until Eofx or SP(c) or (c=chr(13));
FStr:=false;
FSeek(fp-1);
end;

Function FindString(s : string; next : boolean; endline: byte; af : boolean):
boolean;
var
   c : char;
begin
FindString:=false;
if not(next) then begin if af then FSeek(190) else FSeek(0) end;
repeat
if FStr(s) then
  begin
  repeat
  c:=readC;
  until not SP(c);
  FSeek(fp-1);
  g:='';
  repeat
  c:=readc;
  if (c<>chr(13))and not SP(c) then g:=g+c;
  until (c=chr(13))or(Eofx)or SP(c);
  Fseek(fp-1);
  FindString:=true;
  exit;
  end;

repeat
if not(Eofx) then c:=readc;
until Eofx or(c=chr(endline));
if Eofx then exit;
until false;
end;

Function SeekLine( b : byte) : boolean;
begin
Seekline:=true;
repeat
until (readc=char(b)) or EoFx;
if EoFx then SeekLine:=false;
end;

Procedure ReadString;
var
   c : char;
begin
g1:='';
repeat
c:=readc;
until not SP(c)or(Eofx)or(c=chr(13));
Fseek(fp-1);
if not SP(c) then
begin
repeat
c:=readc;
if (c<>chr(13))and not SP(c) then g1:=g1+c;
until (c=chr(13))or(Eofx)or SP(c);
Fseek(fp-1);
end;
end;

Procedure ReadLine;
var
   c : char;
begin
g1:='';
repeat
c:=readc;
until not SP(c)or(Eofx)or(c=chr(13));
Fseek(fp-1);
if not SP(c) then
begin
repeat
c:=readc;
if (c<>chr(13)) then g1:=g1+c;
until (c=chr(13))or(Eofx);
c:=readc; if (c<>chr(10))and not EoFx then Fseek(fp-1);
end;
end;

Function LowCase(c : char) : char;
var
   a : byte;
begin
a:=byte(c);

if (c>='A') and (c<='Z') then a:=a+byte('a')-byte('A');

c:=char(a);
LowCase:=c;
end;


Procedure ReadStringL;
var
   c : char;
begin
g1:='';
if EofX then exit;
repeat
c:=readc;
until not SP(c)or(Eofx)or(c=chr(13));
Fseek(fp-1);
if not SP(c) then
begin
repeat
c:=readc;
if (c<>chr(13))and not SP(c) then g1:=g1+LowCase(c);
until (c=chr(13))or(Eofx)or SP(c);
if not EoFx then Fseek(fp-1);
end;
end;

Procedure StoreName ( num : integer; s : string);
var
   t1,t2 : integer;
begin
t1:=num div 1500;
t2:=num - (t1 * 1500);
t1:=t1+1;
e[t1]^.Name[t2]:=s;
end;

Procedure StoreDir ( num : integer; s : string);
var
   t1,t2 : integer;
begin
t1:=num div 1500;
t2:=num - (t1 * 1500);
t1:=t1+1;
e[t1]^.Dir[t2]:=s;
end;

Procedure StoreW ( num : integer; b : byte);
var
   t1,t2 : integer;
begin
t1:=num div 1500;
t2:=num - (t1 * 1500);
t1:=t1+1;
e[t1]^.W[t2]:=b;
end;

Function ReadName ( num : integer) : string;
var
   t1,t2 : integer;
begin
t1:=num div 1500;
t2:=num - (t1 * 1500);
t1:=t1+1;
ReadName:=e[t1]^.Name[t2];
end;

Function ReadDir ( num : integer) : string;
var
   t1,t2 : integer;
begin
t1:=num div 1500;
t2:=num - (t1 * 1500);
t1:=t1+1;
ReadDir:=e[t1]^.Dir[t2];
end;

Function ReadW ( num : integer) : byte;
var
   t1,t2 : integer;
begin
t1:=num div 1500;
t2:=num - (t1 * 1500);
t1:=t1+1;
ReadW:=e[t1]^.W[t2];
end;

Function C0TS(s : string) : string;
var
   x : integer;
   t : string;
begin
t:='';
for x:=1 to length(s) do if s[x]<>chr(0) then T:=T+s[x];
C0TS:=t;
end;

Procedure CutLast( c : char);
var
   x : integer;
   s : string;
   test : boolean;
begin
s:='';
g2:='';
test:=true;
for x:=length(g1) downto 1 do
begin
if (g1[x]<>c)and test then s:=s+g1[x] else test:=false;
end;
for x:=length(s) downto 1 do g2:=g2+s[x];
end;

Function CutFirst(c : char): string;
var
   x : integer;
   s : string;
begin
s:='';
for x:=1 to length(g1) do if g1[x]<>c then s:=s+g1[x] else
begin
CutFirst:=s;
exit;
end;
CutFirst:=s;

end;

Function CheckDir(s : string) : boolean;
var
   m : string;
begin
CheckDir:=true;
for cb:=1 to c1b do
begin
if ReadDir(cb) = s then exit;
end;
CheckDir:=false;
end;


Procedure AddSt( s: string);
var
   x,y : integer;
   c   : char;
begin
for x:=1 to length(s) do
begin
c:=s[x];

if (c>='') and (c<='') then

   begin
   y:=byte(c)-byte('');
   c:=char(Win[y]);
   end;
Write(fc,c);
end;
end;

Procedure AddCL;
var
   c : char;
begin
c:=char(13);
Write(fc,c);
c:=char(10);
Write(fc,c);
end;

Procedure Up;
var
   x : integer;
begin
gu:='';
for x:=1 to length(gtemp) do gu:=gu+UpCase(gtemp[x]);
end;


var
   x,y    : integer;
   Server : string;
   C1,C2,C3,C4,C5 : string;
   posx : integer;
   pathx,pathz : string;
   c           : char;
   gfx         : string;
   Num,Nam     : string;
   cf          : string;
   counter     : integer;

begin
New(buffer);
for x:=1 to 4 do New(e[x]);

pathx:={'c:\install\}'files.bbs';
if ParamCount<>0 then pathx:=ParamStr(1);
pathz:={'c:\install\}'target.htm';
if ParamCount>1 then pathz:=ParamStr(2);
Num:='0';
if ParamCount>2 then Num:=ParamStr(3);
Nam:='_____________';
if ParamCount>3 then begin
Nam:='';
for x:=4 to ParamCount do begin Nam:=Nam+ParamStr(x); if x<>ParamCount then
Nam:=Nam+' '; end;
end;


Ofile({'c:\install\}'inet-ref.ctl');
if Not FindString('PATHSERVER ',false,10,false) then
 begin
 WriteLn('Can''t find PATHSERVER string');
 halt;
 end;
Server:=g;
if Not FindString('COLOR1 ',false,10,false) then
 begin
 WriteLn('Can''t find COLOR1 string');
 halt;
 end;
C1:=g;
if Not FindString('COLOR2 ',false,10,false) then
 begin
 WriteLn('Can''t find COLOR2 string');
 halt;
 end;
C2:=g;
if Not FindString('COLOR3 ',false,10,false) then
 begin
 WriteLn('Can''t find COLOR3 string');
 halt;
 end;
C3:=g;
if Not FindString('COLOR4 ',false,10,false) then
 begin
 WriteLn('Can''t find COLOR4 string');
 halt;
 end;
C4:=g;
if Not FindString('COLOR5 ',false,10,false) then
 begin
 WriteLn('Can''t find COLOR5 string');
 halt;
 end;
C5:=g;
CFile;

assign(fc,pathz);
rewrite(fc);
seek(fc,0);
AddST('<HTML>'); AddCL;
AddST('<HEAD>'); AddCL;
AddST('<TITLE>᪮᪠  REFERATs -  "'+Nam+'"['+Num+']</TITLE>'); AddCL;
AddST('</HEAD>'); AddCL;
AddST('<BODY ALINK="'+C3+'" VLINK="'+C4+'" LINK="'+C5+'">'); AddCL;
AddST('<BASE TARGET="two"><CENTER>');
AddST('<TABLE WIDTH=90% ALIGN=center BORDER=0 CELLPADDING=10 CELLSPACING=3>');
AddCL;
AddST('<CAPTION ALIGN=top><FONT SIZE=10 COLOR="#0000FF">'+Nam+'</FONT></CAPTION>'); AddCL;

Counter:=0;

posx:=0;
Ofile(pathx);
repeat
ReadStringL;
if (g1<>'') and not EoFx then
begin
if counter=0 then begin AddCL; AddST('<TR>'); end;
AddCL;
gtemp:=g1;
cf:=CutFirst('.');
for y:=1 to length(cf) do cf[y]:=UpCase(cf[y]);
ReadLine;
repeat
c:=readc;
if SP(c) then begin gfx:=g1; ReadLine; g1:=gfx+' '+g1; end;
until not SP(c);
FSeek(fp-1);

if posx=0 then
 begin
 Up;
 AddST('<TD BGCOLOR="'+C1+'"><A HREF="'+Server+Num+'/'+gu+'">'+gu+'</A></TD>'); AddCL;
 AddST('<TD BGCOLOR="'+C1+'">'+g1+'</TD>'); AddCL;
 AddST('<TD BGCOLOR="'+C1+'"><A HREF="'+Server+Num+'/'+cf+'.INF" ><CENTER>INF</CENTER></A></TD>');
 AddSt('</TR>');
 AddCL;

 end
 else
 begin
 Up;
 AddST('<TD BGCOLOR="'+C2+'"><A HREF="'+Server+Num+'/'+gu+'">'+gu+'</A></TD>'); AddCL;
 AddST('<TD BGCOLOR="'+C2+'">'+g1+'</TD>'); AddCL;
 AddST('<TD BGCOLOR="'+C2+'"><A HREF="'+Server+Num+'/'+cf+'.INF"><CENTER>INF</CENTER></A></TD>');
 AddSt('</TR>');
 AddCL;
 end;
posx:=posx xor 1;
end;

until g1='';
CFile;

AddCL;
AddST('</TABLE>'); AddCL;
AddST('</CENTER>'); AddCL;
AddST('</BODY>'); AddCL;
AddST('</HTML>'); AddCL;

close(fc);

end.
